﻿using System;
using System.Runtime.Serialization;

namespace Firma.Anwendung.BusinessEntities
{
    /// <summary>
    /// Base class for static data classes
    /// </summary>
    [Serializable]
    [DataContract(Namespace = "http://firma.com/AppName/DataContracts/2009")]
    public abstract class BaseData<T>
    {
        //CustomerID ist vom Typ nchar(5)
        //Alle anderen IDS sind Int32
        private T _staticDataId;
        /// <summary>
        /// Intern Database ID of the busines object
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public T StaticDataId
        {
            get { return _staticDataId; }
            set { _staticDataId = value; }
        }

        /// <summary>
        /// checks for all mandatory fields
        /// </summary>
        /// <returns>true if all mandatory fields are valid, otherwise false</returns>    
        public abstract bool IsValid();
    }
    // Declare the generic class.


}
