﻿using System;
using System.Runtime.Serialization;


namespace Firma.Anwendung.BusinessEntities
{
    /// <summary>
    /// ValidationException class
    /// </summary>
    [Serializable]
    [DataContract(Namespace = "http://firma.com/AppName/DataContracts/2009")]
    public class ValidationException : Exception
    {
        #region Constructors
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="oValidationResult">The nested ValidationResult</param>
        public ValidationException(ValidationResult oValidationResult)
            : base(oValidationResult.Message)
        {
            m_ValidationResult = oValidationResult;
        }

        #endregion

        private ValidationResult m_ValidationResult = null;
        /// <summary>
        /// The result of the Validation.
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public ValidationResult ValidationResult
        {
            get { return m_ValidationResult; }
            set { m_ValidationResult = value; }
        }

    }
}