﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace Firma.Anwendung.BusinessEntities
{
    /// <summary>
    /// The StaticCategories class
    /// </summary>
    [Serializable]
    [DataContract(Namespace = "http://firma.com/AppName/DataContracts/2009")]
    public class Categories : BaseData<Int32>
    {
        private string m_oCategoryName;
        /// <summary>
        /// Name of Category
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string CategoryName
        {
            get { return this.m_oCategoryName; }
            set { this.m_oCategoryName = value; }
        }
        private string m_cDescription;
        /// <summary>
        /// Description of Category
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Description
        {
            get { return this.m_cDescription; }
            set { this.m_cDescription = value; }
        }


        /// <summary>
        /// checks for all mandatory fields
        /// </summary>
        /// <returns>true if all mandatory fields are valid, otherwise false</returns>
        public override bool IsValid()
        {
            if (StaticDataId == 0)
            {
                return false;
            }
            if (CategoryName == null || CategoryName.Length == 0)
            {
                return false;
            }
            return true;
        }
    }
}

