﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace Firma.Anwendung.BusinessEntities
{
    /// <summary>
    /// The StaticCustomer class
    /// </summary>
    [Serializable]
    [DataContract(Namespace = "http://firma.com/AppName/DataContracts/2009")]
    public class Customer : BaseData<string>
    {
        private string m_cCompanyName;
        /// <summary>
        /// Name of the Company
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string CompanyName
        {
            get { return this.m_cCompanyName; }
            set { this.m_cCompanyName = value; }
        }
        private string m_cContactName;
        /// <summary>
        /// Name of the Contact
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ContactName
        {
            get { return this.m_cContactName; }
            set { this.m_cContactName = value; }
        }
        private string m_cContactTitle;
        /// <summary>
        /// ContactTitle of Customer
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ContactTitle
        {
            get { return this.m_cContactTitle; }
            set { this.m_cContactTitle = value; }
        }

        private string m_cAddress;
        /// <summary>
        /// Address of the Customer
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Address
        {
            get { return this.m_cAddress; }
            set { this.m_cAddress = value; }
        }

        private string m_cCity;
        /// <summary>
        /// City of the Customer
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string City
        {
            get { return this.m_cCity; }
            set { this.m_cCity = value; }
        }

        private string m_cPostalCode;
        /// <summary>
        /// PostalCode of the Customer
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string PostalCode
        {
            get { return this.m_cPostalCode; }
            set { this.m_cPostalCode = value; }
        }

        private string m_cCountry;
        /// <summary>
        /// Country of the Customer
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Country
        {
            get { return this.m_cCountry; }
            set { this.m_cCountry = value; }
        }

        private string m_cPhone;
        /// <summary>
        /// Phone of the Customer
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Phone
        {
            get { return this.m_cPhone; }
            set { this.m_cPhone = value; }
        }

        private string m_cFax;
        /// <summary>
        /// Fax of the Customer
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Fax
        {
            get { return this.m_cFax; }
            set { this.m_cFax = value; }
        }

        /// <summary>
        /// checks for all mandatory fields
        /// </summary>
        /// <returns>true if all mandatory fields are valid, otherwise false</returns>
        public override bool IsValid()
        {
            if (StaticDataId == null || StaticDataId.Length != 5)
            {
                return false;
            }
            if (CompanyName == null || CompanyName.Length == 0)
            {
                return false;
            }
            return true;
        }
    }
}
