﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace Firma.Anwendung.BusinessEntities
{
    /// <summary>
    /// The StaticCustomer class
    /// </summary>
    [Serializable]
    [DataContract(Namespace = "http://firma.com/AppName/DataContracts/2009")]
    public class Employee : BaseData<Int32>
    {
                private string m_eLastName;
        /// <summary>
        /// Lastname of Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string LastName
        {
            get { return this.m_eLastName; }
            set { this.m_eLastName = value; }
        }

        private string m_eFirstName;
        /// <summary>
        /// Firstname of Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string FirstName
        {
            get { return this.m_eFirstName; }
            set { this.m_eFirstName = value; }
        }
        
        private string m_eTitle;
        /// <summary>
        /// Title
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Title
        {
            get { return this.m_eTitle; }
            set { this.m_eTitle = value; }
        }

        private string m_eTitleOfCourtesy;
        /// <summary>
        /// Title Of Courtesy
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string TitleOfCourtesy
        {
            get { return this.m_eTitleOfCourtesy; }
            set { this.m_eTitleOfCourtesy = value; }
        }

        private DateTime m_eBirthDate;
        /// <summary>
        /// Birthdate of Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public DateTime BirthDate
        {
            get { return this.m_eBirthDate; }
            set { this.m_eBirthDate = value; }
        }

        private DateTime m_eHireDate;
        /// <summary>
        /// Hiredate of Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public DateTime HireDate
        {
            get { return this.m_eHireDate; }
            set { this.m_eHireDate = value; }
        }

        private string m_eAddress;
        /// <summary>
        /// Address of Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Address
        {
            get { return this.m_eAddress; }
            set { this.m_eAddress = value; }
        }
        private string m_eCity;
        /// <summary>
        /// City of Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string City
        {
            get { return this.m_eCity; }
            set { this.m_eCity = value; }
        }

        private string m_ePostalCode;
        /// <summary>
        /// PostalCode of the Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string PostalCode
        {
            get { return this.m_ePostalCode; }
            set { this.m_ePostalCode = value; }
        }
        private string m_eCountry;
        /// <summary>
        /// Country of the Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Country
        {
            get { return this.m_eCountry; }
            set { this.m_eCountry = value; }
        }

        private string m_eHomePhone;
        /// <summary>
        /// Home Phone of the Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string HomePhone
        {
            get { return this.m_eHomePhone; }
            set { this.m_eHomePhone = value; }
        }

        private string m_eExtension;
        /// <summary>
        /// Extension of the Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Extension
        {
            get { return this.m_eExtension; }
            set { this.m_eExtension = value; }
        }

        private string m_eNotes;
        /// <summary>
        /// Notes of the Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Notes
        {
            get { return this.m_eNotes; }
            set { this.m_eNotes = value; }
        }

        private string m_eReportsTo;
        /// <summary>
        /// ReportsTo - Boss of the Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ReportsTo
        {
            get { return this.m_eReportsTo; }
            set { this.m_eReportsTo = value; }
        }


        /// <summary>
        /// checks for all mandatory fields
        /// </summary>
        /// <returns>true if all mandatory fields are valid, otherwise false</returns>
        public override bool IsValid()
        {
            if (StaticDataId == 0)
            {
                return false;
            }
            if (LastName == null || LastName.Length == 0)
            {
                return false;
            }
            if (FirstName == null || FirstName.Length == 0)
            {
                return false;
            }
            return true;
        }
    }
}