﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace Firma.Anwendung.BusinessEntities
{
    /// <summary>
    /// The StaticCustomer class
    /// </summary>
    [Serializable]
    [DataContract(Namespace = "http://firma.com/AppName/DataContracts/2009")]
    public class Order : BaseData<Int32>
    {

        private string m_oCustomerID;
        /// <summary>
        /// ID of the Customer
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string CustomerID
        {
            get { return this.m_oCustomerID; }
            set { this.m_oCustomerID = value; }
        }
        private Int32 m_oEmployeeId;
        /// <summary>
        /// Id of the Employee
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int32 EmployeeId
        {
            get { return this.m_oEmployeeId; }
            set { this.m_oEmployeeId = value; }
        }
        private DateTime m_oOrderDate;
        /// <summary>
        /// Date of the Order
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public DateTime OrderDate
        {
            get { return this.m_oOrderDate; }
            set { this.m_oOrderDate = value; }
        }

        private DateTime m_oRequiredDate;
        /// <summary>
        /// Required Date of the Order
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public DateTime RequiredDate
        {
            get { return this.m_oRequiredDate; }
            set { this.m_oRequiredDate = value; }
        }

        private DateTime m_oShippedDate;
        /// <summary>
        /// Shipped Date of the Order
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public DateTime ShippedDate
        {
            get { return this.m_oShippedDate; }
            set { this.m_oShippedDate = value; }
        }

        private decimal m_oFreight;
        /// <summary>
        /// Freight Cost of Order
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public decimal Freight
        {
            get { return this.m_oFreight; }
            set { this.m_oFreight = value; }
        }

        private string m_oShipName;
        /// <summary>
        /// Class of the Customer
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ShipName
        {
            get { return this.m_oShipName; }
            set { this.m_oShipName = value; }
        }
        private string m_oShipAddress;
        /// <summary>
        /// Ship to Name
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ShipAddress
        {
            get { return this.m_oShipAddress; }
            set { this.m_oShipAddress = value; }
        }
        private string m_oShipCity;
        /// <summary>
        /// Ship to City
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ShipCity
        {
            get { return this.m_oShipCity; }
            set { this.m_oShipCity = value; }
        }

        private string m_oShipRegion;
        /// <summary>
        /// Ship to Region
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ShipRegion
        {
            get { return this.m_oShipRegion; }
            set { this.m_oShipRegion = value; }
        }

        private string m_oShipPostalCode;
        /// <summary>
        /// Ship to Postal Code
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ShipPostalCode
        {
            get { return this.m_oShipPostalCode; }
            set { this.m_oShipPostalCode = value; }
        }

        private string m_oShipCountry;
        /// <summary>
        /// Ship to Country
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ShipCountry
        {
            get { return this.m_oShipCountry; }
            set { this.m_oShipCountry = value; }
        }

        /// <summary>
        /// checks for all mandatory fields
        /// </summary>
        /// <returns>true if all mandatory fields are valid, otherwise false</returns>
        public override bool IsValid()
        {
            if (StaticDataId == 0)
            {
                return false;
            }
            return true;
        }
    }
}

