﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace Firma.Anwendung.BusinessEntities
{
    /// <summary>
    /// The OrderDetail class
    /// </summary>
    [Serializable]
    [DataContract(Namespace = "http://firma.com/AppName/DataContracts/2009")]
    public class OrderDetail 
    {

        private Int32 m_odOrderId;
        /// <summary>
        /// ID of the Order
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int32 OrderID
        {
            get { return this.m_odOrderId; }
            set { this.m_odOrderId = value; }
        }

        private Int32 m_odProductID;
        /// <summary>
        /// ID of the Product
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int32 ProductID
        {
            get { return this.m_odProductID; }
            set { this.m_odProductID = value; }
        }
        private decimal m_odUnitPrice;
        /// <summary>
        /// Price of Item
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public decimal UnitPrice
        {
            get { return this.m_odUnitPrice; }
            set { this.m_odUnitPrice = value; }
        }
        private Int16 m_odQuantity;
        /// <summary>
        /// Quantity of Items
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int16 Quantity
        {
            get { return this.m_odQuantity; }
            set { this.m_odQuantity = value; }
        }

        private float m_odDiscount;
        /// <summary>
        /// Discount
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public float Discount
        {
            get { return this.m_odDiscount; }
            set { this.m_odDiscount = value; }
        }


        /// <summary>
        /// checks for all mandatory fields
        /// </summary>
        /// <returns>true if all mandatory fields are valid, otherwise false</returns>
        public bool IsValid()
        {
            if (OrderID == 0)
            {
                return false;
            }
            if (ProductID == 0)
            {
                return false;
            }
            if (UnitPrice == 0)
            {
                return false;
            }
            if (Quantity == 0)
            {
                return false;
            }
            return true;
        }
    }

    /// <summary>
    /// The OrderDetailProductDetail class
    /// </summary>
    [Serializable]
    [DataContract(Namespace = "http://firma.com/AppName/DataContracts/2009")]
    public class OrderDetailProductDetail
    {
        private Int32 m_odOrderId;
        /// <summary>
        /// ID of the Order
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int32 OrderID
        {
            get { return this.m_odOrderId; }
            set { this.m_odOrderId = value; }
        }
        private Int32 m_odProductID;
        /// <summary>
        /// ID of the Product
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int32 ProductID
        {
            get { return this.m_odProductID; }
            set { this.m_odProductID = value; }
        }

        private string m_pProductName;
        /// <summary>
        /// Name of the Product
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ProductName
        {
            get { return this.m_pProductName; }
            set { this.m_pProductName = value; }
        }

        private decimal m_pUnitPrice;
        /// <summary>
        /// Price per Unit
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public decimal UnitPrice
        {
            get { return this.m_pUnitPrice; }
            set { this.m_pUnitPrice = value; }
        }

        private Int16 m_odQuantity;
        /// <summary>
        /// Quantity of Items
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int16 Quantity
        {
            get { return this.m_odQuantity; }
            set { this.m_odQuantity = value; }
        }

        private float m_odDiscount;
        /// <summary>
        /// Discount
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public float Discount
        {
            get { return this.m_odDiscount; }
            set { this.m_odDiscount = value; }
        }

        private decimal m_odpEffectivePrice;
        /// <summary>
        /// EffectivePrice
        /// <summary>
        [DataMember(EmitDefaultValue = false)]
        public decimal EffectivePrice
        {
            get { return m_odpEffectivePrice; }
            set { m_odpEffectivePrice = value; }
        }

        private decimal m_odpTotalPrice;
        /// <summary>
        /// TotalPrice
        /// <summary>
        [DataMember(EmitDefaultValue = false)]
        public decimal TotalPrice
        {
            get { return m_odpTotalPrice; }
            set { m_odpTotalPrice = value; }
        }

        private string m_odQuantityPerUnit;
        /// <summary>
        /// Quantity of Items in an Unit
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string QuantityPerUnit
        {
            get { return this.m_odQuantityPerUnit; }
            set { this.m_odQuantityPerUnit = value; }
        }

        private Int16 m_pUnitsInStock;
        /// <summary>
        /// available Units in Stock
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int16 UnitsInStock
        {
            get { return this.m_pUnitsInStock; }
            set { this.m_pUnitsInStock = value; }
        }

        private string m_oCategoryName;
        /// <summary>
        /// Name of Category
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string CategoryName
        {
            get { return this.m_oCategoryName; }
            set { this.m_oCategoryName = value; }
        }
        private string m_cDescription;
        /// <summary>
        /// Description of Category
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string Description
        {
            get { return this.m_cDescription; }
            set { this.m_cDescription = value; }
        }


    }

}