﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace Firma.Anwendung.BusinessEntities
{
    /// <summary>
    /// The Products class
    /// </summary>
    [Serializable]
    [DataContract(Namespace = "http://firma.com/AppName/DataContracts/2009")]
    public class Products : BaseData<Int32>
    {

        private string m_pProductName;
        /// <summary>
        /// Name of the Product
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string ProductName
        {
            get { return this.m_pProductName; }
            set { this.m_pProductName = value; }
        }

        private Int32 m_pCategoryID;
        /// <summary>
        /// ID of the associated Category
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int32 CategoryID
        {
            get { return this.m_pCategoryID; }
            set { this.m_pCategoryID = value; }
        }

        private string m_odQuantityPerUnit;
        /// <summary>
        /// Quantity of Items in an Unit
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public string QuantityPerUnit
        {
            get { return this.m_odQuantityPerUnit; }
            set { this.m_odQuantityPerUnit = value; }
        }

        private decimal m_pUnitPrice;
        /// <summary>
        /// Price per Unit
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public decimal UnitPrice
        {
            get { return this.m_pUnitPrice; }
            set { this.m_pUnitPrice = value; }
        }

        private Int16 m_pUnitsInStock;
        /// <summary>
        /// available Units in Stock
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int16 UnitsInStock
        {
            get { return this.m_pUnitsInStock; }
            set { this.m_pUnitsInStock = value; }
        }
        private Int16 m_pUnitsOnOrder;
        /// <summary>
        /// number of Units in the Order
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int16 UnitsOnOrder
        {
            get { return this.m_pUnitsOnOrder; }
            set { this.m_pUnitsOnOrder = value; }
        }
        private Int16 m_pReorderLevel;
        /// <summary>
        /// Level of Reorder
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public Int16 ReorderLevel
        {
            get { return this.m_pReorderLevel; }
            set { this.m_pReorderLevel = value; }
        }
        private bool m_pDiscontinued;
        /// <summary>
        /// Is the Product discontinued?
        /// </summary>
        [DataMember(EmitDefaultValue = false)]
        public bool Discontinued
        {
            get { return this.m_pDiscontinued; }
            set { this.m_pDiscontinued = value; }
        }

        /// <summary>
        /// checks for all mandatory fields
        /// </summary>
        /// <returns>true if all mandatory fields are valid, otherwise false</returns>
        public override bool IsValid()
        {
            if (StaticDataId == 0)
            {
                return false;
            }
            if (ProductName == null || ProductName.Length == 0)
            {
                return false;
            }
            return true;
        }

    }
}