﻿using System.ServiceModel;
using Firma.Anwendung.BusinessEntities;

namespace Firma.Anwendung.Services
{
    /// <summary>
    /// IETBaseService
    /// </summary>
    [ServiceContract(Namespace = "Firma.Anwendung.Services", Name = "IETBaseService", SessionMode = SessionMode.NotAllowed)]
    public interface IETBaseService
    {

        /// <summary>
        /// Get information (e.g. name, version) about the service
        /// </summary>
        /// <returns>Information about the service</returns>
        [OperationContract]
        [FaultContract(typeof(ServiceFault))]
        ServiceInfo GetServiceInfo();

        /// <summary>
        /// Check the entries of the service specific configuration.
        /// In case of errors an ServiceFault will be thrown.
        /// </summary>
        [OperationContract]
        [FaultContract(typeof(ServiceFault))]
        bool CheckServiceConfiguration();

    }
}
