﻿using System;
using Firma.Anwendung.Hosting;
using Firma.Anwendung.Utility;

namespace Firma.Anwendung.Hosting
{
    class Program
    {
        static void Main(string[] args)
        {
            LogUtility oLogUtility = new LogUtility("ETConsoleHosting");
            oLogUtility.TraceLog(LogLevel.Info, "Start ETonsoleHosting");

            try
            {
                Console.ForegroundColor = ConsoleColor.Green;

                ETHostingLibrary oETHostingLibrary = new ETHostingLibrary(Platform.Console);
                ConsoleKeyInfo oConsoleKeyInfo;
                if (oETHostingLibrary.Open())
                {
                    Console.WriteLine("\nETConsoleHosting is running.\n\nPress 'q' to stop all services.");
                    do
                    {
                        oConsoleKeyInfo = Console.ReadKey();
                    } while (oConsoleKeyInfo.Key.ToString().ToLower() != "q");

                    oETHostingLibrary.Close();
                }
            }
            catch (Exception oException)
            {
                Console.ForegroundColor = ConsoleColor.Red;
                Console.WriteLine("ETConsoleHosting is not running!\n");
                Console.WriteLine("Exception: " + oException.ToString());
                Console.ReadKey();
            }
        }
    }
}
