USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_DeleteCustomers]    Script Date: 11/18/2009 15:28:23 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spCustomer_DeleteCustomers]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spCustomer_DeleteCustomers]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_DeleteCustomers]    Script Date: 11/18/2009 15:28:23 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE [dbo].[spCustomer_DeleteCustomers]
	 @customerID nchar(5)
AS
BEGIN
	
    DELETE FROM [dbo].[Customers]
	WHERE [CustomerID]=@customerID
	
	IF @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No CustomerID = %s found. No Customer Row deleted!', 16, 2, @customerID)
	END
    
END



GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_GetAllCustomers]    Script Date: 11/18/2009 15:28:39 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spCustomer_GetAllCustomers]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spCustomer_GetAllCustomers]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_GetAllCustomers]    Script Date: 11/18/2009 15:28:39 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE [dbo].[spCustomer_GetAllCustomers]    
AS
BEGIN
	SET NOCOUNT OFF
	
	SELECT
	[customers].[CustomerID] AS 'CustomerID',
	[customers].[CompanyName] AS 'CompanyName',
	[customers].[ContactName] AS 'ContactName',
	[customers].[ContactTitle] AS 'ContactTitle',
	[customers].[Address] AS 'Address',
	[customers].[City] AS 'City',
	[customers].[PostalCode] AS 'PostalCode',
	[customers].[Country] AS 'Country',
	[customers].[Phone] AS 'Phone',
	[customers].[Fax] AS 'Fax'
FROM [dbo].[Customers] [customers]
ORDER BY [customers].[CustomerID]

END



GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_GetCustomerByID]    Script Date: 11/18/2009 15:28:59 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spCustomer_GetCustomerByID]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spCustomer_GetCustomerByID]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_GetCustomerByID]    Script Date: 11/18/2009 15:28:59 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE [dbo].[spCustomer_GetCustomerByID] 
	@customerID nchar(5)
AS
BEGIN

	SET NOCOUNT OFF
	
	SELECT
	[customers].[CustomerID] AS 'CustomerID',
	[customers].[CompanyName] AS 'CompanyName',
	[customers].[ContactName] AS 'ContactName',
	[customers].[ContactTitle] AS 'ContactTitle',
	[customers].[Address] AS 'Address',
	[customers].[City] AS 'City',
	[customers].[PostalCode] AS 'PostalCode',
	[customers].[Country] AS 'Country',
	[customers].[Phone] AS 'Phone',
	[customers].[Fax] AS 'Fax'
	FROM [dbo].[Customers] [customers]
	WHERE [CustomerID]=@customerID
	
	IF @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No such CustomerID = %s found', 16, 2, @customerID)
	END

END



GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_GetCustomersForName]    Script Date: 11/18/2009 15:29:20 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spCustomer_GetCustomersForName]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spCustomer_GetCustomersForName]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_GetCustomersForName]    Script Date: 11/18/2009 15:29:20 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE [dbo].[spCustomer_GetCustomersForName] 
	@companyName nvarchar(40)
AS
BEGIN

	SET NOCOUNT OFF
	
	SELECT
	[customers].[CustomerID] AS 'CustomerID',
	[customers].[CompanyName] AS 'CompanyName',
	[customers].[ContactName] AS 'ContactName',
	[customers].[ContactTitle] AS 'ContactTitle',
	[customers].[Address] AS 'Address',
	[customers].[City] AS 'City',
	[customers].[PostalCode] AS 'PostalCode',
	[customers].[Country] AS 'Country',
	[customers].[Phone] AS 'Phone',
	[customers].[Fax] AS 'Fax'
	FROM [dbo].[Customers] [customers]
	WHERE [CompanyName] LIKE @companyName
	
	IF @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No Company found with Name like %s ', 16, 2, @companyName)
	END

END



GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_InsertCustomers]    Script Date: 11/18/2009 15:29:30 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spCustomer_InsertCustomers]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spCustomer_InsertCustomers]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_InsertCustomers]    Script Date: 11/18/2009 15:29:30 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE [dbo].[spCustomer_InsertCustomers]
	@customerID nchar(5),
	@companyName nvarchar(40),
	@contactName nvarchar(30) = NULL,
	@contactTitle nvarchar(30) = NULL,
    @address nvarchar(60) = NULL,
	@city nvarchar(15) = NULL,
	@postalCode nvarchar(10) = NULL,
	@country nvarchar(15) = NULL,
	@phone nvarchar(24) = NULL,
	@fax nvarchar(24) = NULL
AS
Declare @mycount int
BEGIN
	SELECT @mycount =  COUNT (CustomerID) from [dbo].[Customers] where CustomerID = @customerID
END
IF @mycount = 0
	BEGIN
		SET NOCOUNT ON
		INSERT INTO [dbo].[Customers] ([CustomerID], [CompanyName], [ContactName], [ContactTitle], [Address], [City], [PostalCode], [Country], [Phone], [Fax])
		VALUES (@customerID, @companyName, @contactName, @contactTitle, @address, @city, @postalCode, @country, @phone, @fax )
	END	
ELSE
	BEGIN
		RAISERROR ('CustomerID %s already exists', 16, 1, @customerID)
	END    



GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_UpdateCustomers]    Script Date: 11/18/2009 15:29:39 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spCustomer_UpdateCustomers]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spCustomer_UpdateCustomers]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spCustomer_UpdateCustomers]    Script Date: 11/18/2009 15:29:39 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE [dbo].[spCustomer_UpdateCustomers]
    @address nvarchar(60) = NULL,
    @before_address nvarchar(60) = NULL,
	@city nvarchar(15) = NULL,
	@before_city nvarchar(15) = NULL,
	@companyName nvarchar(40),
	@before_companyName nvarchar(40),
	@contactName nvarchar(30) = NULL,
	@before_contactName nvarchar(30) = NULL,
	@contactTitle nvarchar(30) = NULL,
	@before_contactTitle nvarchar(30) = NULL,
	@country nvarchar(15) = NULL,
	@before_country nvarchar(15) = NULL,
	@customerID nchar(5),
	@fax nvarchar(24) = NULL,
	@before_fax nvarchar(24) = NULL,
	@phone nvarchar(24) = NULL,
	@before_phone nvarchar(24) = NULL,
	@before_postalCode nvarchar(10) = NULL,
	@postalCode nvarchar(10) = NULL
AS
BEGIN

	BEGIN
	UPDATE [dbo].[Customers] 
	SET [Address] = @address, 
		[City] = @city, 
		[CompanyName] = @companyName, 
		[ContactName] = @contactName, 
		[ContactTitle] = @contactTitle, 
		[Country] = @country, 
		[Fax] = @fax, 
		[Phone] = @phone, 
		[PostalCode] = @postalCode
	WHERE	([CustomerID]=@customerID) AND 
			([CompanyName] = @before_companyName) AND 
			(([Address] IS NULL AND @before_address IS NULL) OR [Address]=@before_address) AND 
			(([City] IS NULL AND @before_city IS NULL) OR [City]=@before_city) AND  
			(([ContactName] IS NULL AND @before_contactName IS NULL) OR [ContactName]=@before_contactName) AND  
			(([ContactTitle] IS NULL AND @before_contactTitle IS NULL) OR [ContactTitle] = @before_contactTitle) AND  
			(([Country] IS NULL AND @before_country IS NULL) OR [Country]=@before_country) AND  
			(([Fax] IS NULL AND @before_fax IS NULL) OR [Fax]=@before_fax) AND  
			(([Phone] IS NULL AND @before_phone IS NULL) OR [Phone]=@before_phone) AND  
			(([PostalCode] IS NULL AND @before_postalCode IS NULL) OR [PostalCode]=@before_postalCode)
	END
	IF @@ROWCOUNT = 0
	BEGIN
		RAISERROR('Concurrent update error. Update aborted.', 16, 2)
	END

END



GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_CreateOrderDetail]    Script Date: 11/18/2009 15:29:48 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spOrder_CreateOrderDetail]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spOrder_CreateOrderDetail]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_CreateOrderDetail]    Script Date: 11/18/2009 15:29:48 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spOrder_CreateOrderDetail]
	@orderID int,
	@productID int,
	@unitPrice money,
	@quantity int,
	@discount float = 0.0
AS
BEGIN
	SET NOCOUNT OFF
	INSERT INTO [dbo].[Order Details] ([OrderID], [ProductID], [UnitPrice], [Quantity], [Discount])
		VALUES (@orderID, @productID, @unitPrice, @quantity, @discount)
	IF @@ROWCOUNT = 0
	BEGIN
		RAISERROR ('Insert of new Order Detail for OrderID %d failed!', 16, 1, @orderID)
	END    
		
END

GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_DeleteOrder]    Script Date: 11/18/2009 15:29:58 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spOrder_DeleteOrder]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spOrder_DeleteOrder]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_DeleteOrder]    Script Date: 11/18/2009 15:29:58 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE [dbo].[spOrder_DeleteOrder]
	 @orderID Integer
AS
BEGIN
	
    DELETE FROM [dbo].[Orders]
	WHERE [OrderID]=@orderID
	
	IF @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No OrderID = %s found. No Order deleted!', 16, 2, @orderID)
	END
    
END



GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_GetOrderByID]    Script Date: 11/18/2009 15:30:06 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spOrder_GetOrderByID]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spOrder_GetOrderByID]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_GetOrderByID]    Script Date: 11/18/2009 15:30:06 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


CREATE PROCEDURE [dbo].[spOrder_GetOrderByID]

@orderId int

	
AS
SET NOCOUNT OFF
BEGIN
	SELECT	OrderID, 
			CustomerID, 
			EmployeeID, 
			OrderDate, 
			RequiredDate, 
			ShippedDate, 
			Freight, 
			ShipName, 
			ShipAddress, 
			ShipCity,
			ShipRegion,
			ShipPostalCode,
			ShipCountry
	FROM Orders
	WHERE OrderID = @orderId
	
	if @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No such OrderID = %d found!', 16, 1, @orderId)
	END
	
END


GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_GetOrderDetailsByOrderID]    Script Date: 11/18/2009 15:30:15 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spOrder_GetOrderDetailsByOrderID]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spOrder_GetOrderDetailsByOrderID]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_GetOrderDetailsByOrderID]    Script Date: 11/18/2009 15:30:15 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spOrder_GetOrderDetailsByOrderID] ( @orderID int )
AS

SET NOCOUNT OFF
BEGIN
	Select	OrderID,
			ProductID,
			UnitPrice,
			Quantity,
			Discount
	FROM [Order Details]
	WHERE ( OrderID = @orderID )
END
IF @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No Order Details found for OrderID %d!', 16, 1, @orderID)
	END

RETURN

GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_GetOrderDetailsProductDetails]    Script Date: 11/18/2009 15:30:26 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spOrder_GetOrderDetailsProductDetails]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spOrder_GetOrderDetailsProductDetails]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_GetOrderDetailsProductDetails]    Script Date: 11/18/2009 15:30:26 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spOrder_GetOrderDetailsProductDetails] @orderID int
AS
select 
	[Order Details].OrderID,
	[Order Details].ProductID,
	Products.ProductName,
	Products.UnitPrice,
	[Order Details].Quantity,
	[Order Details].Discount,
	CAST(Products.UnitPrice - Products.UnitPrice * [Order Details].Discount as  money) as EffectivePrice,
	CAST([Order Details].Quantity * (Products.UnitPrice - Products.UnitPrice * [Order Details].Discount) as money) as TotalPrice,
	Products.QuantityPerUnit,
	Products.UnitsInStock,
	Categories.CategoryName,
	Categories.Description	 
from [Order Details]
inner join Products on Products.ProductID = [Order Details].ProductID
inner join Categories on Products.CategoryID = Categories.CategoryID
where [Order Details].OrderID = @orderID
RETURN

GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_GetOrdersforCustomer]    Script Date: 11/18/2009 15:30:34 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spOrder_GetOrdersforCustomer]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spOrder_GetOrdersforCustomer]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_GetOrdersforCustomer]    Script Date: 11/18/2009 15:30:34 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO


CREATE PROCEDURE [dbo].[spOrder_GetOrdersforCustomer]

@customerId nvarchar(5)

	
AS
SET NOCOUNT OFF
BEGIN
	SELECT	OrderID, 
			CustomerID, 
			EmployeeID, 
			OrderDate, 
			RequiredDate, 
			ShippedDate, 
			Freight, 
			ShipName, 
			ShipAddress, 
			ShipCity,
			ShipRegion,
			ShipPostalCode,
			ShipCountry
	FROM Orders
	WHERE CustomerID = @customerId
	ORDER BY OrderDate DESC 
	
	if @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No Orders found for CustomerID = %s found!', 16, 1, @customerId)
	END
	
END


GO
USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_InsertOrder]    Script Date: 11/18/2009 15:30:46 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spOrder_InsertOrder]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spOrder_InsertOrder]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_InsertOrder]    Script Date: 11/18/2009 15:30:46 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO



CREATE PROCEDURE [dbo].[spOrder_InsertOrder]
	@PKId int out,
	@customerID nvarchar(5),
	@employeeID int = NULL,
	@orderDate datetime = NULL,
	@requiredDate datetime = NULL,
	@shippedDate datetime = NULL,
	@freight money = NULL,
	@shipName nvarchar(40) = NULL,
	@shipAddress nvarchar(60) = NULL,
	@shipCity nvarchar(15) = NULL,
	@shipRegion nvarchar(15) = NULL,
	@shipPostalCode nvarchar(10) = NULL,
	@shipCountry nvarchar(15) = NULL
AS
Declare @mycount int
BEGIN
	SELECT @mycount =  COUNT (CustomerID) from [dbo].[Customers] where CustomerID = @customerID
END
IF @mycount > 0
	BEGIN
		SET NOCOUNT ON
			INSERT INTO [dbo].[Orders] ([CustomerID], [EmployeeID], [OrderDate], [RequiredDate], [ShippedDate], [Freight], [ShipName], [ShipAddress], [ShipCity], [ShipRegion], [ShipPostalCode], [ShipCountry])
			VALUES (@customerID, @employeeID, @orderDate, @requiredDate, @shippedDate, @freight, @shipName, @shipAddress, @shipCity, @shipRegion, @shipPostalCode, @shipCountry )
			Select @PKId = scope_identity()
		SET NOCOUNT OFF
	END
ELSE
	BEGIN
		RAISERROR ('No such CustomerID %s found!', 16, 1, @customerID)
	END    


GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_UpdateOrder]    Script Date: 11/18/2009 15:30:55 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spOrder_UpdateOrder]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spOrder_UpdateOrder]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_UpdateOrder]    Script Date: 11/18/2009 15:30:55 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spOrder_UpdateOrder]
	@orderId Integer,
    @customerID nchar(5) = NULL,
    @before_customerID nchar(5) = NULL,
    @employeeID Integer = 0,
    @before_employeeID Integer = 0,
    @orderDate datetime = NULL,
    @before_orderDate datetime = NULL,
    @requiredDate datetime = NULL,
    @before_requiredDate datetime = NULL,
    @shippedDate datetime = NULL,
    @before_shippedDate datetime = NULL,
    @shipName nvarchar(40) = NULL,
    @before_shipName nvarchar(40) = NULL,
    @shipAddress nvarchar(60) = NULL,
    @before_shipAddress nvarchar(60) = NULL,
	@shipCity nvarchar(15) = NULL,
    @before_shipCity nvarchar(15) = NULL,
    @shipRegion nvarchar(15) = NULL,
    @before_shipRegion nvarchar(15) = NULL,
    @shipCountry nvarchar(15) = NULL,
    @before_shipCountry nvarchar(15) = NULL,
    @shipPostalCode nvarchar(60) = NULL,
    @before_shipPostalCode nvarchar(60) = NULL,
    @freight money = 0,
    @before_freight money =0
AS
BEGIN

	BEGIN
	UPDATE [dbo].[Orders] 
	SET [CustomerID] = @customerID, 
		[EmployeeID] = @employeeID, 
		[OrderDate] = @orderDate, 
		[RequiredDate] = @requiredDate, 
		[ShippedDate] = @shippedDate, 
		[ShipName] = @shipName, 
		[ShipAddress] = @shipAddress, 
		[ShipCity] = @shipCity, 
		[ShipRegion] = @shipRegion,
		[ShipCountry] = @shipCountry,
		[ShipPostalCode] = @shipPostalCode,
		[Freight] = @freight
	WHERE	([OrderID] = @orderId) AND 
			([CustomerID] = @before_customerID) AND 
			(([EmployeeID] IS NULL AND @before_employeeID IS NULL) OR [EmployeeID]=@before_employeeID) AND 
			(([OrderDate] IS NULL AND @before_orderDate IS NULL) OR [OrderDate]=@before_orderDate) AND  
			(([RequiredDate] IS NULL AND @before_requiredDate IS NULL) OR [RequiredDate]=@before_requiredDate) AND  
			(([ShippedDate] IS NULL AND @before_shippedDate IS NULL) OR [ShippedDate] = @before_shippedDate) AND  
			(([ShipName] IS NULL AND @before_shipName IS NULL) OR [ShipName]=@before_shipName) AND  
			(([ShipAddress] IS NULL AND @before_shipAddress IS NULL) OR [ShipAddress]=@before_shipAddress) AND  
			(([ShipCity] IS NULL AND @before_shipCity IS NULL) OR [ShipCity]=@before_shipCity) AND  
			(([ShipRegion] IS NULL AND @before_shipRegion IS NULL) OR [ShipRegion]=@before_shipRegion) AND
			(([ShipCountry] IS NULL AND @before_shipCountry IS NULL) OR [ShipCountry]=@before_shipCountry) AND
			(([ShipPostalCode] IS NULL AND @before_shipPostalCode IS NULL) OR [ShipPostalCode]=@before_shipPostalCode) AND
			(([Freight] IS NULL AND @before_freight IS NULL) OR [Freight]=@before_freight) 
	END
	IF @@ROWCOUNT = 0
	BEGIN
		RAISERROR('Concurrent update error. Update aborted.', 16, 2)
	END

END

GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_UpdateOrderDetail]    Script Date: 11/18/2009 15:31:04 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spOrder_UpdateOrderDetail]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spOrder_UpdateOrderDetail]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spOrder_UpdateOrderDetail]    Script Date: 11/18/2009 15:31:04 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spOrder_UpdateOrderDetail]
	@orderID Integer,
    @productID Integer = 0,
    @before_productID Integer = 0,
    @discount real = 0.0,
    @before_discount real = 0.0,
    @quantity smallint =0,
    @before_quantity smallint =0,
    @unitprice money = 0.0,
    @before_unitprice money = 0.0
AS
BEGIN
	BEGIN
	UPDATE [dbo].[Order Details] 
	SET [OrderID] = @orderID, 
		[ProductID] = @productID, 
		[Discount] = @discount, 
		[UnitPrice] = @unitprice, 
		[Quantity] = @quantity
	WHERE	([OrderID] = @orderId) AND 
			(([ProductID] IS NULL AND @before_productID IS NULL) OR [ProductID]=@before_productID) AND 
			(([Discount] IS NULL AND @before_discount IS NULL) OR [Discount]=@before_discount) AND  
			(([Quantity] IS NULL AND @before_quantity IS NULL) OR [Quantity]=@before_quantity) AND  
			(([UnitPrice] IS NULL AND @before_unitprice IS NULL) OR [UnitPrice] = @before_unitprice) 
	END
	IF @@ROWCOUNT = 0
	BEGIN
		RAISERROR('Concurrent update error. Update aborted.', 16, 2)
	END

END

GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spProduct_GetCategories]    Script Date: 11/18/2009 15:32:21 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spProduct_GetCategories]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spProduct_GetCategories]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spProduct_GetCategories]    Script Date: 11/18/2009 15:32:21 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spProduct_GetCategories]
AS
BEGIN
Select	CategoryID,
		CategoryName,
		Description
FROM    Categories
ORDER BY CategoryName

END
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spProduct_GetProductByName]    Script Date: 11/18/2009 15:32:29 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spProduct_GetProductByName]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spProduct_GetProductByName]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spProduct_GetProductByName]    Script Date: 11/18/2009 15:32:29 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spProduct_GetProductByName] ( @productName nvarchar(40) )
AS
SET NOCOUNT OFF
BEGIN
	SELECT 
		    Products.ProductID,
			Products.ProductName,
			Products.CategoryID,
			Products.QuantityPerUnit,
			Products.UnitPrice,
			Products.UnitsInStock,
			Products.UnitsOnOrder,
			Products.ReorderLevel,
			Products.Discontinued
FROM        Products 
WHERE       (ProductName = @productName)	
	if @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No such ProductName = %d found!', 16, 1, @productName)
	END
	
END


GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spProduct_GetProductByProductID]    Script Date: 11/18/2009 15:32:37 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spProduct_GetProductByProductID]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spProduct_GetProductByProductID]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spProduct_GetProductByProductID]    Script Date: 11/18/2009 15:32:37 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spProduct_GetProductByProductID] ( @productID int )
AS
SET NOCOUNT OFF
BEGIN
	SELECT 
		    Products.ProductID,
			Products.ProductName,
			Products.CategoryID,
			Products.QuantityPerUnit,
			Products.UnitPrice,
			Products.UnitsInStock,
			Products.UnitsOnOrder,
			Products.ReorderLevel,
			Products.Discontinued
FROM        Products 
WHERE       (ProductID = @productID)	
	if @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No such ProductID = %d found!', 16, 1, @productID)
	END
	
END

GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spProduct_GetProductsByID]    Script Date: 11/18/2009 15:32:43 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spProduct_GetProductsByID]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spProduct_GetProductsByID]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spProduct_GetProductsByID]    Script Date: 11/18/2009 15:32:43 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spProduct_GetProductsByID]( @categoryID int)

as
SET NOCOUNT OFF
BEGIN
	SELECT	ProductID,
			ProductName,
			CategoryID,
			QuantityPerUnit,
			UnitPrice,
			UnitsInStock,
			UnitsOnOrder,
			ReorderLevel,
			Discontinued
	FROM Products
	WHERE CategoryID = @categoryID
	
	if @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No such CategoryID = %d found!', 16, 1, @categoryID)
	END
	
END


GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spProduct_GetProductsByName]    Script Date: 11/18/2009 15:32:52 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[spProduct_GetProductsByName]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[spProduct_GetProductsByName]
GO

USE [Northwind]
GO

/****** Object:  StoredProcedure [dbo].[spProduct_GetProductsByName]    Script Date: 11/18/2009 15:32:52 ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[spProduct_GetProductsByName] ( @categoryName nvarchar(40))
AS
SET NOCOUNT OFF
BEGIN
	SELECT 
		    Products.ProductID,
			Products.ProductName,
			Products.CategoryID,
			Products.QuantityPerUnit,
			Products.UnitPrice,
			Products.UnitsInStock,
			Products.UnitsOnOrder,
			Products.ReorderLevel,
			Products.Discontinued
FROM        Categories INNER JOIN
            Products ON Categories.CategoryID = Products.CategoryID
WHERE       (Categories.CategoryName = @categoryName)	
	if @@ROWCOUNT = 0
	BEGIN
		RAISERROR('No such CategoryName = %d found!', 16, 1, @categoryName)
	END
	
END


GO


