﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Firma.Anwendung.Utility
{
    /// <summary>
    /// LogLevel
    /// </summary>
    public enum LogLevel
    {
        /// <summary>
        /// Debug
        /// </summary>
        Debug,
        /// <summary>
        /// Info
        /// </summary>
        Info,
        /// <summary>
        /// Warning
        /// </summary>
        Warning,
        /// <summary>
        /// Error
        /// </summary>
        Error,
        /// <summary>
        /// Fatal
        /// </summary>
        Fatal
    };

    /// <summary>
    /// TraceBasic
    /// </summary>
    [Serializable]
    public abstract class TraceBasic : IDisposable
    {
        /// <summary>
        /// SourceName
        /// </summary>
        protected string m_strSourceName = string.Empty;

        /// <summary>
        /// Flag Disposed
        /// </summary>
        protected bool m_fDisposed = false;

        /// <summary>
        /// TraceBasic
        /// </summary>
        /// <param name="strSourceName"></param>
        protected TraceBasic(string strSourceName)
        {
            m_strSourceName = strSourceName;
        }

        /// <summary>
        /// TraceLog
        /// </summary>
        /// <param name="eTraceLevel"></param>
        /// <param name="strFormat"></param>
        /// <param name="oArgs"></param>
        public abstract void TraceLog(LogLevel eTraceLevel, string strFormat, params object[] oArgs);

        /// <summary>
        /// TraceException
        /// </summary>
        /// <param name="eTraceLevel"></param>
        /// <param name="strComment"></param>
        /// <param name="oException"></param>
        public abstract void TraceException(LogLevel eTraceLevel, string strComment, Exception oException);

        /// <summary>
        /// Dispose
        /// </summary>
        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        /// <summary>
        /// Dispose
        /// </summary>
        /// <param name="fDisposing"></param>
        protected abstract void Dispose(bool fDisposing);
    }
}

