﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Text;
using System.Threading;
using Firma.Anwendung.Hosting;
using Firma.Anwendung.Service;
using Firma.Anwendung.Utility;


#pragma warning disable 168


[assembly: Module("Firma.Anwendung.Service.ServiceHosting")]

namespace Firma.Anwendung.Service
{
    /// <summary>
    /// ServiceHosting
    /// </summary>
    public class ServiceHosting : BaseModule
    {
        private ETHostingLibrary m_oETHostingLibrary = null;

        /// <summary>
        /// ServiceHosting
        /// </summary>
        public ServiceHosting()
        {
            m_oLogUtility = new LogUtility(typeof(ServiceHosting));
        }

        /// <summary>
        /// Init
        /// </summary>
        /// <returns></returns>
        public override bool Init()
        {
            bool fResult = false;
            
            m_oLogUtility.TraceLog(LogLevel.Info, "Init");

            try
            {
                if (ReadConfigFile(typeof(ServiceHosting)))
                {
                    // Konfiguration lesen
                    //m_oConfiguration.AppSettings.Settings["..."].Value;
                    fResult = true;
                }
            }
            catch (Exception oException)
            {
                m_oLogUtility.TraceException(LogLevel.Error, "Init", oException);
            }

            return fResult;
        }

        /// <summary>
        /// Start
        /// </summary>
        /// <returns></returns>
        public override bool Start()
        {
            bool fResult = false;
            m_oLogUtility.TraceLog(LogLevel.Info, "Start");

            try
            {
                m_oETHostingLibrary = new ETHostingLibrary(Platform.WindowsService);
                fResult = m_oETHostingLibrary.Open();
            }
            catch (Exception oException)
            {
                m_oLogUtility.TraceException(LogLevel.Error, "Start", oException);
            }

            return fResult;
        }

        /// <summary>
        /// Stop
        /// </summary>
        /// <returns></returns>
        public override bool Stop()
        {
            bool fResult = false;

            try
            {
                if (m_oETHostingLibrary != null)
                {
                    m_oETHostingLibrary.Close();
                    fResult = true;
                }

                m_oLogUtility.TraceLog(LogLevel.Info, "Stop");
            }
            catch (Exception oException)
            {
                m_oLogUtility.TraceException(LogLevel.Error, "Start", oException);
            }

            return fResult;
        }
    }
}
